<?php

namespace Schaffen\BankIntegration\Cnab\Conciliacao\Cnab240;

use Carbon\Carbon;
use Schaffen\BankIntegration\Contracts\Cnab\Conciliacao\Cnab240\HeaderLote as HeaderLoteContract;
use Schaffen\BankIntegration\MagicTrait;

class HeaderLote implements HeaderLoteContract
{
    use MagicTrait;
    /**
     * @var string
     */
    public $codBanco;

    /**
     * @var string
     */
    public $numeroLoteRetorno;

    /**
     * @var string
     */
    public $tipoRegistro;

    /**
     * @var string
     */
    public $tipoOperacao;

    /**
     * @var string
     */
    public $tipoServico;

    /**
     * @var string
     */
    public $versaoLayoutLote;

    /**
     * @var string
     */
    public $tipoInscricao;

    /**
     * @var string
     */
    public $numeroInscricao;

    /**
     * @var string
     */
    public $convenio;

    /**
     * @var string
     */
    public $agencia;

    /**
     * @var string
     */
    public $agenciaDv;

    /**
     * @var string
     */
    public $conta;

    /**
     * @var string
     */
    public $contaDv;

    /**
     * @var string
     */
    public $nomeEmpresa;

    /**
     * @var string
     */
    public $dataInicial;

    



    /**
     * @return string
     */
    public function getCodBanco()
    {
        return $this->codBanco;
    }

    /**
     * @param string $codBanco
     *
     * @return $this
     */
    public function setCodBanco($codBanco)
    {
        $this->codBanco = $codBanco;

        return $this;
    }

    /**
     * @return string
     */
    public function getNumeroLoteRetorno()
    {
        return $this->numeroLoteRetorno;
    }

    /**
     * @param string $numeroLoteRetorno
     *
     * @return $this
     */
    public function setNumeroLoteRetorno($numeroLoteRetorno)
    {
        $this->numeroLoteRetorno = $numeroLoteRetorno;

        return $this;
    }

    /**
     * @return string
     */
    public function getTipoRegistro()
    {
        return $this->tipoRegistro;
    }

    /**
     * @param string $tipoRegistro
     *
     * @return $this
     */
    public function setTipoRegistro($tipoRegistro)
    {
        $this->tipoRegistro = $tipoRegistro;

        return $this;
    }

    /**
     * @return string
     */
    public function getTipoOperacao()
    {
        return $this->tipoOperacao;
    }

    /**
     *
     * @param string $tipoOperacao
     * @return $this
     */
    public function setTipoOperacao($tipoOperacao)
    {
        $this->tipoOperacao = $tipoOperacao;

        return $this;
    }


    /**
     * @return string
     */
    public function getTipoServico()
    {
        return $this->tipoServico;
    }

    /**
     * @param string $tipoServico
     *
     * @return $this
     */
    public function setTipoServico($tipoServico)
    {
        $this->tipoServico = $tipoServico;

        return $this;
    }


    /**
     * @return string
     */
    public function getVersaoLayoutLote()
    {
        return $this->versaoLayoutLote;
    }

    /**
     * @param string $versaoLayoutLote
     *
     * @return $this
     */
    public function setVersaoLayoutLote($versaoLayoutLote)
    {
        $this->versaoLayoutLote = $versaoLayoutLote;

        return $this;
    }


    /**
     * @return string
     */
    public function getTipoInscricao()
    {
        return $this->tipoInscricao;
    }

    /**
     *
     * @param $tipoInscricao
     *
     * @return $this
     */
    public function setTipoInscricao($tipoInscricao)
    {
        $this->tipoInscricao = $tipoInscricao;

        return $this;
    }


    /**
     * @return string
     */
    public function getNumeroInscricao()
    {
        return $this->numeroInscricao;
    }

    /**
     * @param string $numeroInscricao
     *
     * @return $this
     */
    public function setNumeroInscricao($numeroInscricao)
    {
        $this->numeroInscricao = $numeroInscricao;

        return $this;
    }

    /**
     * @return string
     */
    public function getConvenio()
    {
        return $this->convenio;
    }

    /**
     * @param string $convenio
     *
     * @return $this
     */
    public function setConvenio($convenio)
    {
        $this->convenio = $convenio;

        return $this;
    }

    /**
     * @return string
     */
    public function getAgencia()
    {
        return $this->agencia;
    }

    /**
     * @param string $agencia
     *
     * @return $this
     */
    public function setAgencia($agencia)
    {
        $this->agencia = $agencia;

        return $this;
    }


    /**
     * @return string
     */
    public function getAgenciaDv()
    {
        return $this->agenciaDv;
    }

    /**
     * @param string $agenciaDv
     *
     * @return $this
     */
    public function setAgenciaDv($agenciaDv)
    {
        $this->agenciaDv = $agenciaDv;

        return $this;
    }

    /**
     * @return string
     */
    public function getConta()
    {
        return $this->conta;
    }

    /**
     * @param string $conta
     *
     * @return $this
     */
    public function setConta($conta)
    {
        $this->conta = $conta;

        return $this;
    }

    /**
     * @return string
     */
    public function getContaDv()
    {
        return $this->contaDv;
    }

    /**
     * @param string $contaDv
     *
     * @return $this
     */
    public function setContaDv($contaDv)
    {
        $this->contaDv = $contaDv;

        return $this;
    }

    /**
     * @return string
     */
    public function getNomeEmpresa()
    {
        return $this->nomeEmpresa;
    }

    /**
     * @param string $nomeEmpresa
     *
     * @return $this
     */
    public function setNomeEmpresa($nomeEmpresa)
    {
        $this->nomeEmpresa = $nomeEmpresa;

        return $this;
    }   

    // /**
    //  * @param string $format
    //  *
    //  * @return string
    //  */
    // public function getDataInicial($format = 'd/m/Y')
    // {
    //     return $this->data instanceof Carbon
    //         ? $format === false ? $this->dataInicial : $this->dataInicial->format($format)
    //         : null;
    // }

    // /**
    //  * @param string $dataInicial
    //  *
    //  * @param string $format
    //  *
    //  * @return $this
    //  */
    // public function setDataInicial($dataInicial, $format = 'dmY')
    // {
    //     $this->dataInicial = trim($dataInicial, '0 ') ? Carbon::createFromFormat($format, $dataInicial) : null;

    //     return $this;
    // }

     /**
     * @param string 
     */
    public function getDataInicial()
    {
        return $this->dataVencimento;
    }

    /**
     * @param $dataLancamento
     *
     * @return $this
     */
    public function setDataInicial($dataInicial)
    {
        $this->dataInicial = date_format(date_create_from_format('dmY', $dataInicial), 'd/m/Y');;

        return $this;
    }
}
